//
//      **************************************************************
//       JdeBP C++ Library Routines      General Public Licence v1.00
//          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
//      **************************************************************
//
// CONSOLE I/O (MS-DOS) and BORLAND VIDEO FUNCTIONS
//

#if !defined(___STDDEF_H_INCLUDED)
#include <_stddef.h>
#endif
#if !defined(___PORTINT_H_INCLUDED)
#include <_portint.h>       // PORT and INTERRUPT FUNCTIONS
#endif

#if !defined(__CONIO_H_INCLUDED)

#define NULL    _NULL

#define _NOCURSOR      0
#define _SOLIDCURSOR   1
#define _NORMALCURSOR  2

#define BLINK       128 /* blink bit */

#ifndef _CONIO_H_COLORS
enum COLORS {
    BLACK,      BLUE,           GREEN,      CYAN,
    RED,        MAGENTA,        BROWN,      LIGHTGRAY,
    DARKGRAY,   LIGHTBLUE,      LIGHTGREEN, LIGHTCYAN,
    LIGHTRED,   LIGHTMAGENTA,   YELLOW,     WHITE
};
#define _CONIO_H_COLORS
#endif

struct text_info {
    unsigned char winleft;
    unsigned char wintop;
    unsigned char winright;
    unsigned char winbottom;
    unsigned char attribute;
    unsigned char normattr;
    unsigned char currmode;
    unsigned char screenheight;
    unsigned char screenwidth;
    unsigned char curx;
    unsigned char cury;
};

enum text_modes { LASTMODE=-1, BW40=0, C40, BW80, C80, MONO=7, C4350=64 };

extern "C" {

char *      __cdecl  cgets   (char *);
int         __cdecl  cprintf (const char *, ...);
int         __cdecl  cputs   (const char *);
int         __cdecl  cscanf  (const char *, ...);
int         __cdecl  getch   (void);
int         __cdecl  getche  (void);
int         __cdecl  putch   (int);
int         __cdecl  ungetch (int);

int         __cdecl  kbhit   (void);

void        __cdecl  clreol  (void);
void        __cdecl  clrscr  (void);
void        __cdecl  gotoxy  (int, int);
int         __cdecl  wherex  (void);
int         __cdecl  wherey  (void);
void        __cdecl  delline (void);
int         __cdecl  gettext (int, int, int, int, void *);
void        __cdecl  gettextinfo (struct text_info *);
void        __cdecl  highvideo   (void);
void        __cdecl  insline (void);
void        __cdecl  lowvideo(void);
int         __cdecl  movetext(int, int, int, int, int, int);
void        __cdecl  normvideo(void);
int         __cdecl  puttext (int, int, int, int, void *);
void        __cdecl  textattr(int);
void        __cdecl  textbackground (int);
void        __cdecl  textcolor(int);
void        __cdecl  textmode(int);
void        __cdecl  window  (int, int, int, int);

void        __cdecl  _setcursortype(int);
char *      __cdecl  getpass (const char *);

extern  int __cdecl  directvideo;
extern  int __cdecl  _wscroll;

}

#define __CONIO_H_INCLUDED
#endif
