//
//      **************************************************************
//       JdeBP C++ Library Routines      General Public Licence v1.00
//          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
//      **************************************************************
//
// DOS FUNCTIONS and SEGMENT:OFFSET MAIPULATIONS (MS-DOS)
//

#if !defined(___STDDEF_H_INCLUDED)
#include <_stddef.h>
#endif
#if !defined(___PORTINT_H_INCLUDED)
#include <_portint.h>       // PORT and INTERRUPT FUNCTIONS
#endif
#if !defined(___ATTRIB_H_INCLUDED)
#include <_attrib.h>        // File attribute constants
#endif

#ifndef _DOS_H_INCLUDED

#define NULL    _NULL

#define MK_FP(s,o) _MK_FP(s,o)
#define FP_SEG(fp) _FP_SEG(fp)
#define FP_OFF(fp) _FP_OFF(fp)

struct DOSERROR {
	int exterror;
	char errclass;
	char action;
	char locus;
};

struct find_t {
	char        reserved[21];
	char        attrib;
	unsigned    wr_time;
	unsigned    wr_date;
	long        size;
	char        name[13];
};

struct dosdate_t {
	unsigned char day;          /* 1-31 */
	unsigned char month;        /* 1-12 */
	unsigned int year;          /* 1980-2099 */
	unsigned char dayofweek;    /* 0-6, 0=Sunday */
};
struct dostime_t {
	unsigned char hour;     /* 0-23 */
	unsigned char minute;   /* 0-59 */
	unsigned char second;   /* 0-59 */
	unsigned char hsecond;  /* 0-99 */
};

struct diskfree_t {
	unsigned total_clusters;
	unsigned avail_clusters;
	unsigned sectors_per_cluster;
	unsigned bytes_per_sector;
};

extern "C" {

//
//  Unsupported _dos calls
//
void        __cdecl  _dos_fullname(const char *, char *) ;
void        __cdecl  _dos_keep   (unsigned, unsigned);
unsigned    __cdecl  _dos_leadbytetable  (const void far * far * ) ;
void        interrupt (_far * __cdecl getvect    (unsigned))();
void        __cdecl  setvect (unsigned, void (interrupt _far *)());

#ifdef __MSC__
void        __cdecl  _chain_intr (void (__cdecl _interrupt _far *)());
void        interrupt (_far * __cdecl _dos_getvect(unsigned))();
void        __cdecl  _dos_setvect    (unsigned, void (interrupt _far *)());
#endif

//
//  Some of these are supported.  Eventually all of them should be.
//
unsigned    __cdecl  _dos_allocmem(unsigned short, unsigned short *);
unsigned    __cdecl  _dos_close  (int);
unsigned    __cdecl  _dos_creat  (const char *, unsigned, int *);
unsigned    __cdecl  _dos_creatnew   (const char *, unsigned, int *);
unsigned    __cdecl  _dos_findfirst  (const char *, unsigned, struct find_t *);
unsigned    __cdecl  _dos_findnext   (struct find_t *);
unsigned    __cdecl  _dos_freemem    (unsigned);
void        __cdecl  _dos_getdate    (struct dosdate_t *);
void        __cdecl  _dos_getdrive   (unsigned *);
unsigned    __cdecl  _dos_getdiskfree    (unsigned, struct diskfree_t *);
unsigned    __cdecl  _dos_getfileattr    (const char *, unsigned *);
unsigned    __cdecl  _dos_getftime   (int, unsigned *, unsigned *);
void        __cdecl  _dos_gettime    (struct dostime_t *);
unsigned    __cdecl  _dos_open   (const char *, unsigned, int *);
unsigned    __cdecl  _dos_read   (int, void _far *, unsigned, unsigned *);
unsigned    __cdecl  _dos_seek   (int, long, int, long *);
unsigned    __cdecl  _dos_setblock   (unsigned, unsigned, unsigned *);
unsigned    __cdecl  _dos_setdate    (struct dosdate_t *);
void        __cdecl  _dos_setdrive   (unsigned, unsigned *);
unsigned    __cdecl  _dos_setfileattr    (const char *, unsigned);
unsigned    __cdecl  _dos_setftime   (int, unsigned, unsigned);
unsigned    __cdecl  _dos_settime    (struct dostime_t *);
unsigned    __cdecl  _dos_write  (int, const void _far *, unsigned, unsigned *);
int         __cdecl  _dos_exterr (struct DOSERROR *);

//
//  Global variables related to DOS
//
extern unsigned char    __cdecl _osmajor;        // DOS major version
extern unsigned char    __cdecl _osminor;        // DOS minor version
extern unsigned int     __cdecl _osversion;

}

#define _DOS_H_INCLUDED
#endif
