/*
 *      **************************************************************
 *       JdeBP C++ Library Routines      General Public Licence v1.00
 *          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
 *      **************************************************************
 *
 * MATHEMATICAL FUNCTIONS (ANSI)
 *
 */

#if !defined(___STDDEF_H_INCLUDED)
#include <_stddef.h>
#endif

typedef const union {
    unsigned short W[4];        // For accessing as an array of short
    double D;                   // For accessing as a double
} _DoubleConst;

extern "C" {

double  __cdecl acos     (double);
double  __cdecl asin     (double);
double  __cdecl atan     (double);
double  __cdecl atan2    (double, double);
double  __cdecl atof     (const char  *);
double  __cdecl ceil     (double);
double  __cdecl cos      (double);
double  __cdecl cosh     (double);
double  __cdecl exp      (double);
double  __cdecl fabs     (double);
double  __cdecl floor    (double);
double  __cdecl fmod     (double, double);
double  __cdecl frexp    (double, int  *);
double  __cdecl ldexp    (double, int);
double  __cdecl log      (double);
double  __cdecl log10    (double);
double  __cdecl modf     (double, double  *);
double  __cdecl pow      (double, double);
double  __cdecl sin      (double);
double  __cdecl sinh     (double);
double  __cdecl sqrt     (double);
double  __cdecl tan      (double);
double  __cdecl tanh     (double);

extern _DoubleConst __cdecl  _HugeVal;

}

#define HUGE_VAL _HugeVal.D
