//
//    *******************************************************************
//      JdeBP C++ Library Routines      General Public Licence v1.00
//          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
//    *******************************************************************
//

//
//  OS/2 DOS API
//

#ifndef _DOSTYPES_DEFINED

struct FDATE {
	unsigned day:   5;
	unsigned month: 4;
	unsigned year:  7;
} ;

struct FTIME {
	unsigned twosecs:   5;
	unsigned minutes:   6;
	unsigned hours:     5;
} ;

struct DOSDATETIME {
	unsigned char   hours;
	unsigned char   minutes;
	unsigned char   seconds;
	unsigned char   hundredths;
	unsigned char   day;
	unsigned char   month;
	unsigned short  year;
	short           timezone;
	unsigned char   weekday;
} ;

struct DOSCOUNTRYCODE {
	unsigned short country;
	unsigned short codepage;
} ;

struct DOSCOUNTRYINFO {
	unsigned short country;
	unsigned short codepage;
	unsigned short fsDateFmt;
	char   szCurrency[5];
	char   szThousandsSeparator[2];
	char   szDecimal[2];
	char   szDateSeparator[2];
	char   szTimeSeparator[2];
	unsigned char  fsCurrencyFmt;
	unsigned char  cDecimalPlace;
	unsigned char  fsTimeFmt;
	unsigned short abReserved1[2];
	char   szDataSeparator[2];
	unsigned short abReserved2[5];
} ;

struct PIDINFO {
	unsigned int    pid ;
	unsigned int    tid ;
	unsigned int    pidParent ;
} ;

struct RESULTCODES {
	unsigned int    codeTerminate ;
	unsigned int    codeResult ;
} ;

struct GINFOSEG {
	ULONG   time;
	ULONG   msecs;
	UCHAR   hour;
	UCHAR   minutes;
	UCHAR   seconds;
	UCHAR   hundredths;
	USHORT  timezone;
	USHORT  cusecTimerInterval;
	UCHAR   day;
	UCHAR   month;
	USHORT  year;
	UCHAR   weekday;
	UCHAR   uchMajorVersion;
	UCHAR   uchMinorVersion;
	UCHAR   chRevisionLetter;
	UCHAR   sgCurrent;
	UCHAR   sgMax;
	UCHAR   cHugeShift;
	UCHAR   fProtectModeOnly;
	USHORT  pidForeground;
	UCHAR   fDynamicSched;
	UCHAR   csecMaxWait;
	USHORT  cmsecMinSlice;
	USHORT  cmsecMaxSlice;
	USHORT  bootdrive;
	UCHAR   amecRAS[32];
} ;

struct LINFOSEG {
	USHORT  pidCurrent;
	USHORT  pidParent;
	USHORT  prtyCurrent;
	USHORT  tidCurrent;
	USHORT  sgCurrent;
	USHORT  sgSub;
	USHORT  fForeground;
} ;

struct MUXSEM {
	USHORT zero;
	USHORT hsem;
} ;

struct MUXSEMLIST {
	USHORT  cmxs;
	MUXSEM  amxs[16];
} ;

struct STATUSDATA {
	USHORT cb;
	USHORT SelectInd;
	USHORT BindInd;
} ;

#define _DOSTYPES_DEFINED
#endif

extern "C" {



#if defined(INCL_DOS) || defined(INCL_DOSPROCESS)

void  APIENTRY  DosBeep     (USHORT, USHORT);
void  APIENTRY  DosExit     (USHORT, USHORT);

#define EXIT_THREAD         0
#define EXIT_PROCESS        1

USHORT APIENTRY DosCreateThread (void (__far *)(void), UINT __far *, unsigned char __far *) ;
USHORT APIENTRY DosResumeThread (UINT) ;
USHORT APIENTRY DosSuspendThread (UINT) ;

USHORT APIENTRY DosCWait (UINT, UINT, RESULTCODES __far *, UINT __far *, UINT) ;
void  APIENTRY  DosSleep    (unsigned long);

#define DCWA_PROCESS        0
#define DCWA_PROCESSTREE    1
#define DCWW_WAIT   0
#define DCWW_NOWAIT 1

#define TC_EXIT          0
#define TC_HARDERROR     1
#define TC_TRAP          2
#define TC_KILLPROCESS   3

USHORT APIENTRY DosEnterCritSec (void) ;
USHORT APIENTRY DosExitCritSec (void) ;
USHORT APIENTRY DosExitList (UINT, void (__far *)(UINT)) ;

#define EXLST_ADD       1
#define EXLST_REMOVE    2
#define EXLST_EXIT      3

USHORT APIENTRY DosExecPgm (char __far *, USHORT, USHORT, char __far *, char __far *, RESULTCODES __far *, char __far *);

#define EXEC_SYNC           0
#define EXEC_ASYNC          1
#define EXEC_ASYNCRESULT    2
#define EXEC_TRACE          3
#define EXEC_BACKGROUND     4
#define EXEC_LOAD           5

USHORT APIENTRY DosGetPid   (PIDINFO __far *);
USHORT APIENTRY DosGetPrty (UINT, UINT __far *, UINT) ;
USHORT APIENTRY DosSetPrty (UINT, UINT, short int, UINT) ;

#define PRTYS_PROCESS       0
#define PRTYS_PROCESSTREE   1
#define PRTYS_THREAD        2

#define PRTYC_NOCHANGE      0
#define PRTYC_IDLETIME      1
#define PRTYC_REGULAR       2
#define PRTYC_TIMECRITICAL  3

USHORT APIENTRY DosKillProcess (UINT, UINT) ;

#define DKP_PROCESS         0
#define DKP_PROCESSTREE     1

#endif /* INCL_DOSPROCESS */




#if defined(INCL_DOS) || defined(INCL_DOSINFOSEG)

#define PT_FULLSCREEN       0
#define PT_REALMODE         1
#define PT_WINDOWABLEVIO    2
#define PT_PM               3
#define PT_DETACHED         4

USHORT APIENTRY DosGetInfoSeg (USHORT __far *, USHORT __far *) ;

USHORT APIENTRY DosQSysInfo (USHORT, UCHAR __far *, USHORT) ;

#endif /* INCL_DOSINFOSEG */




#if defined(INCL_DOS) || defined(INCL_DOSFILEMGR)

   // DosSetFilePtr() file position codes

   #define FILE_BEGIN      0x0000   /* Move relative to beginning of file */
   #define FILE_CURRENT    0x0001   /* Move relative to current fptr position */
   #define FILE_END        0x0002   /* Move relative to end of file */

   // DosFindFirst/Next Directory handle types
   #define HDIR_SYSTEM        1     /* Use system handle (1) */
   #define HDIR_CREATE      (-1)    /* Allocate a new, unused handle */

   // DosCopy control bits; may be or'ed together
   #define DCPY_EXISTING   0x0001   /* Copy even if target exists */
   #define DCPY_APPEND     0x0002   /* Append to existing file, do not replace */
   #define DCPY_FAILEAS    0x0004   /* Fail if EAs not supported on target*/

   // DosOpen/DosQFHandState/DosQueryFileInfo et al file attribute
   #define FILE_NORMAL     0x0000
   #define FILE_READONLY   0x0001
   #define FILE_HIDDEN     0x0002
   #define FILE_SYSTEM     0x0004
   #define FILE_DIRECTORY  0x0010
   #define FILE_ARCHIVED   0x0020

   #define FILE_IGNORE     0x10000     /* ignore file attribute in */
									   /* DosSetPath/File Info if */
									   /* this bit is set*/

   #define MUST_HAVE_READONLY      ( (FILE_READONLY  << 8) | FILE_READONLY  )
   #define MUST_HAVE_HIDDEN        ( (FILE_HIDDEN    << 8) | FILE_HIDDEN    )
   #define MUST_HAVE_SYSTEM        ( (FILE_SYSTEM    << 8) | FILE_SYSTEM    )
   #define MUST_HAVE_DIRECTORY     ( (FILE_DIRECTORY << 8) | FILE_DIRECTORY )
   #define MUST_HAVE_ARCHIVED      ( (FILE_ARCHIVED  << 8) | FILE_ARCHIVED  )

   // DosOpen() actions
   #define FILE_EXISTED    0x0001
   #define FILE_CREATED    0x0002
   #define FILE_TRUNCATED  0x0003

   // DosOpen() open flags
   #define FILE_OPEN       0x0001
   #define FILE_TRUNCATE   0x0002
   #define FILE_CREATE     0x0010

   //     this nibble applies if file already exists                xxxx
   #define OPEN_ACTION_FAIL_IF_EXISTS     0x0000  /* ---- ---- ---- 0000 */
   #define OPEN_ACTION_OPEN_IF_EXISTS     0x0001  /* ---- ---- ---- 0001 */
   #define OPEN_ACTION_REPLACE_IF_EXISTS  0x0002  /* ---- ---- ---- 0010 */

   //     this nibble applies if file does not exist           xxxx
   #define OPEN_ACTION_FAIL_IF_NEW        0x0000  /* ---- ---- 0000 ---- */
   #define OPEN_ACTION_CREATE_IF_NEW      0x0010  /* ---- ---- 0001 ---- */

   // DosOpen/DosSetFHandState flags
   #define OPEN_ACCESS_READONLY           0x0000  /* ---- ---- ---- -000 */
   #define OPEN_ACCESS_WRITEONLY          0x0001  /* ---- ---- ---- -001 */
   #define OPEN_ACCESS_READWRITE          0x0002  /* ---- ---- ---- -010 */
   #define OPEN_SHARE_DENYREADWRITE       0x0010  /* ---- ---- -001 ---- */
   #define OPEN_SHARE_DENYWRITE           0x0020  /* ---- ---- -010 ---- */
   #define OPEN_SHARE_DENYREAD            0x0030  /* ---- ---- -011 ---- */
   #define OPEN_SHARE_DENYNONE            0x0040  /* ---- ---- -100 ---- */
   #define OPEN_FLAGS_NOINHERIT           0x0080  /* ---- ---- 1--- ---- */
   #define OPEN_FLAGS_NO_LOCALITY         0x0000  /* ---- -000 ---- ---- */
   #define OPEN_FLAGS_SEQUENTIAL          0x0100  /* ---- -001 ---- ---- */
   #define OPEN_FLAGS_RANDOM              0x0200  /* ---- -010 ---- ---- */
   #define OPEN_FLAGS_RANDOMSEQUENTIAL    0x0300  /* ---- -011 ---- ---- */
   #define OPEN_FLAGS_NO_CACHE            0x1000  /* ---1 ---- ---- ---- */
   #define OPEN_FLAGS_FAIL_ON_ERROR       0x2000  /* --1- ---- ---- ---- */
   #define OPEN_FLAGS_WRITE_THROUGH       0x4000  /* -1-- ---- ---- ---- */
   #define OPEN_FLAGS_DASD                0x8000  /* 1--- ---- ---- ---- */
   #define OPEN_FLAGS_NONSPOOLED          0x00040000

   // DosSearchPath() constants
   #define SEARCH_PATH           0x0000
   #define SEARCH_CUR_DIRECTORY  0x0001
   #define SEARCH_ENVIRONMENT    0x0002
   #define SEARCH_IGNORENETERRS  0x0004


   /************************************************************
   EA Info Levels & Find First/Next
   =========================================
   API's: DosFindFirst, DosQueryFileInfo, DosQueryPathInfo, DosSetFileInfo,
		  DosSetPathInfo
   ************************************************************/

   // File info levels&gml All listed API's
   #define FIL_STANDARD          1     /* Info level 1, standard file info */
   #define FIL_QUERYEASIZE       2     /* Level 2, return Full EA size */
   #define FIL_QUERYEASFROMLIST  3     /* Level 3, return requested EA's */

   // File info levels: Dos...PathInfo only
   #define FIL_QUERYFULLNAME     5     /* Level 5, return fully qualified
										   name of file */

   // DosFsAttach()
   #define FS_ATTACH             0     /* Attach file server */
   #define FS_DETACH             1     /* Detach file server */
   #define FS_SPOOLATTACH        2     /* Register a spooler device */
   #define FS_SPOOLDETACH        3     /* De-register a spooler device */

   // DosFsCtl()
   #define FSCTL_HANDLE          1     /* File Handle directs req routing */
   #define FSCTL_PATHNAME        2     /* Path Name directs req routing */
   #define FSCTL_FSDNAME         3     /* FSD Name directs req routing */

   // defined FSCTL functions
   #define FSCTL_ERROR_INFO      1     /* return error info from FSD */
   #define FSCTL_MAX_EASIZE      2     /* Max ea size for the FSD */

   struct EASIZEBUF {       /* struct for FSCTL fn 2 - max ea size */
	   USHORT  cbMaxEASize;        /* max. size of one EA */
	   ULONG   cbMaxEAListSize;    /* max size of the full EA List */
   } ;



   // DosQueryFSAttach()
   // Information level types (defines method of query)
   #define FSAIL_QUERYNAME       1     /* Return data for a Drive or Device */
   #define FSAIL_DEVNUMBER       2     /* Return data for Ordinal Device # */
   #define FSAIL_DRVNUMBER       3     /* Return data for Ordinal Drive # */

   // Item types (from data structure item "iType")
   #define FSAT_CHARDEV          1     /* Resident character device */
   #define FSAT_PSEUDODEV        2     /* Pusedu-character device */
   #define FSAT_LOCALDRV         3     /* Local drive */
   #define FSAT_REMOTEDRV        4     /* Remote drive attached to FSD */

	struct FSQBUFFER {		/* fsqbuf Data structure for QFSAttach*/
		USHORT  iType;              /* Item type */
		USHORT  cbName;             /* Length of item name, sans NULL */
		UCHAR   szName[1];          /* ASCIIZ item name */
		USHORT  cbFSDName;          /* Length of FSD name, sans NULL */
		UCHAR   szFSDName[1];       /* ASCIIZ FSD name */
		USHORT  cbFSAData;          /* Length of FSD Attach data returned */
		UCHAR   rgFSAData[1];       /* FSD Attach data from FSD */
	} ;

	struct FSQBUFFER2 {		/* fsqbuf Data structure for QFSAttach*/
		USHORT  iType;
		USHORT  cbName;
		USHORT  cbFSDName;
		USHORT  cbFSAData;
		UCHAR   szName[1];
		UCHAR   szFSDName[1];
		UCHAR   rgFSAData[1];
	} ;

	struct SPOOLATTACH { 	/* Data structure for spooler operations */
		USHORT  hNmPipe;            /* Named pipe handle */
		ULONG   ulKey;              /* Attached key */
	} ;


   /*****************************************************************************
   * File System Drive Information&gml DosQueryFSInfo DosSetFSInfo              *
   *****************************************************************************/

   // FS Drive Info Levels
   #define FSIL_ALLOC            1     /* Drive allocation info (Query only) */
   #define FSIL_VOLSER           2     /* Drive Volum/Serial info */

   // DosQueryFHType()
   // Handle classes (low 8 bits of Handle Type)
   #define FHT_DISKFILE          0x0000   /* Disk file handle */
   #define FHT_CHRDEV            0x0001   /* Character device handle */
   #define FHT_PIPE              0x0002   /* Pipe handle */

   // Handle bits (high 8 bits of Handle Type)
	#define FHB_DSKREMOTE         0x8000   /* Remote disk */
	#define FHB_CHRDEVREMOTE      0x8000   /* Remote character device */
	#define FHB_PIPEREMOTE        0x8000   /* Remote pipe */

	struct VOLUMELABEL {		/* vol */
		BYTE cch;
		char szVolLabel[12];
	} ;

	struct FSINFO {		/* fsinf */
		FDATE fdateCreation;
		FTIME ftimeCreation;
		VOLUMELABEL vol;
	} ;

   // HANDTYPE values
   #define HANDTYPE_FILE         0x0000
   #define HANDTYPE_DEVICE       0x0001
   #define HANDTYPE_PIPE         0x0002
   #define HANDTYPE_NETWORK      0x8000

	struct FILELOCK {		/* flock */
		LONG lOffset;
		LONG lRange;
	} ;

   #ifndef __HEV__            /* INCL_SEMAPHORE may also define HEV */
	  #define __HEV__
	  typedef  ULONG    HEV;             /* hev */
	  typedef  HEV      *PHEV;
   #endif

   #ifndef INCL_SAADEFS

	#define CCHMAXPATHCOMP	256		/* Support for HPFS long filenames */

	struct FILEFINDBUF {
		FDATE   fdateCreation;
		FTIME   ftimeCreation;
		FDATE   fdateLastAccess;
		FTIME   ftimeLastAccess;
		FDATE   fdateLastWrite;
		FTIME   ftimeLastWrite;
		unsigned long   cbFile;
		unsigned long   cbFileAlloc;
		unsigned int    attrFile;
		unsigned char   cchName;
		char            achName[CCHMAXPATHCOMP];
	} ;

	struct FILEFINDBUF2 {
		FDATE   fdateCreation;
		FTIME   ftimeCreation;
		FDATE   fdateLastAccess;
		FTIME   ftimeLastAccess;
		FDATE   fdateLastWrite;
		FTIME   ftimeLastWrite;
		unsigned long   cbFile;
		unsigned long   cbFileAlloc;
		unsigned int    attrFile;
		unsigned long	cbList ;			// Added
		unsigned char   cchName;
		char            achName[CCHMAXPATHCOMP];
	} ;

	struct FILEFINDBUF3 {
		ULONG   oNextEntryOffset;			// Added
		FDATE   fdateCreation;
		FTIME   ftimeCreation;
		FDATE   fdateLastAccess;
		FTIME   ftimeLastAccess;
		FDATE   fdateLastWrite;
		FTIME   ftimeLastWrite;
		unsigned long   cbFile;
		unsigned long   cbFileAlloc;
		unsigned long   attrFile;			// Widened
		unsigned char   cchName;
		char            achName[CCHMAXPATHCOMP];
	} ;

	struct FILEFINDBUF4 {
		ULONG   oNextEntryOffset;			// Added
		FDATE   fdateCreation;
		FTIME   ftimeCreation;
		FDATE   fdateLastAccess;
		FTIME   ftimeLastAccess;
		FDATE   fdateLastWrite;
		FTIME   ftimeLastWrite;
		unsigned long   cbFile;
		unsigned long   cbFileAlloc;
		unsigned long   attrFile;			// Widened
		unsigned long	cbList ;			// Added
		unsigned char   cchName;
		char            achName[CCHMAXPATHCOMP];
	} ;

	  /* extended attribute structures */

	  struct GEA {
			BYTE cbName;        /* name length not including NULL */
			char szName[1];     /* attribute name */
	  } ;

	  struct GEALIST {
			ULONG cbList;       /* total bytes of structure including full list */
			GEA list[1];        /* variable length GEA structures */
	  } ;

	  struct FEA {
			BYTE fEA;           /* flags                              */
			BYTE cbName;        /* name length not including NULL */
			USHORT cbValue;     /* value length */
	  } ;

	  /* flags for _FEA.fEA */
	  #define FEA_NEEDEA         0x80     /* need EA bit */

	  struct FEALIST {
			ULONG cbList;       /* total bytes of structure including full list */
			FEA list[1];        /* variable length FEA structures */
	  } ;

	  struct EAOP {
			GEALIST __far *fpGEAList; /* general EA list */
			FEALIST __far *fpFEAList; /* full EA list */
			ULONG oError;
	  } ;

	  struct FEA2 {
			ULONG   oNextEntryOffset;    /* new field */
			BYTE    fEA;
			BYTE    cbName;
			USHORT  cbValue;
			char    szName[1];           /* new field */
	  } ;

	  /* flags for _FEA.fEA */
	  #define FEA_NEEDEA         0x80      /* need EA bit */

	  struct FEA2LIST {
			ULONG   cbList;
			FEA2    list[1];
	  } ;

	  struct GEA2 {
			ULONG   oNextEntryOffset;     /* new field */
			BYTE    cbName;
			char    szName[1];            /* new field */
	  } ;

	  struct GEA2LIST {
			ULONG   cbList;
			GEA2    list[1];
	  } ;

	  struct EAOP2 {
			GEA2LIST   __far *fpGEA2List;       /* GEA set */
			FEA2LIST   __far *fpFEA2List;       /* FEA set */
			ULONG       oError;           /* offset of FEA error */
	  } ;

	  /*
	   * Equates for the types of EAs that follow the convention that we have
	   * established.
	   *
	   * Values 0xFFFE thru 0x8000 are reserved.
	   * Values 0x0000 thru 0x7fff are user definable.
	   * Value  0xFFFC is not used
	   */

	  #define EAT_BINARY      0xFFFE      /* length preceeded binary */
	  #define EAT_ASCII       0xFFFD      /* length preceeded ASCII */
	  #define EAT_BITMAP      0xFFFB      /* length preceeded bitmap */
	  #define EAT_METAFILE    0xFFFA      /* length preceeded metafile */
	  #define EAT_ICON        0xFFF9      /* length preceeded icon */
	  #define EAT_EA          0xFFEE      /* length preceeded ASCII */
										  /* name of associated data (#include) */
	  #define EAT_MVMT        0xFFDF      /* multi-valued, multi-typed field */
	  #define EAT_MVST        0xFFDE      /* multi-valued, single-typed field */
	  #define EAT_ASN1        0xFFDD      /* ASN.1 field */

   #endif  /* !INCL_SAADEFS */


   /* File time and date types */

   struct FILESTATUS {
		   FDATE  fdateCreation;
		   FTIME  ftimeCreation;
		   FDATE  fdateLastAccess;
		   FTIME  ftimeLastAccess;
		   FDATE  fdateLastWrite;
		   FTIME  ftimeLastWrite;
		   ULONG  cbFile;
		   ULONG  cbFileAlloc;
		   USHORT attrFile;
   } ;

   struct FILESTATUS2 : public FILESTATUS {
		   ULONG  cbList;
   } ;

   struct FILESTATUS3 {
		   FDATE  fdateCreation;
		   FTIME  ftimeCreation;
		   FDATE  fdateLastAccess;
		   FTIME  ftimeLastAccess;
		   FDATE  fdateLastWrite;
		   FTIME  ftimeLastWrite;
		   ULONG  cbFile;
		   ULONG  cbFileAlloc;
		   ULONG  attrFile;
   } ;

   struct FILESTATUS4 : public FILESTATUS3 {
		   ULONG  cbList;
   } ;


   struct FSALLOCATE {
		   ULONG  idFileSystem;
		   ULONG  cSectorUnit;
		   ULONG  cUnit;
		   ULONG  cUnitAvail;
		   USHORT cbSector;
   } ;

   /* defines for DosSetPathInfo -pathinfo flag */
   #define DSPI_WRTTHRU    0x10    /* write through */

   struct DENA1 { /* _dena1 level 1 info returned from DosEnumAttribute */
		   UCHAR       reserved;       /* 0 */
		   UCHAR       cbName;         /* length of name exculding NULL */
		   USHORT      cbValue;        /* length of value */
		   UCHAR       szName[1];      /* variable length asciiz name */
   } ;

   typedef FEA2  DENA2;

   /* Infolevels for DosEnumAttribute  */
   #define ENUMEA_LEVEL_NO_VALUE   1L      /* FEA without value */
   /* Reference types for DosEnumAttribute */
   #define ENUMEA_REFTYPE_FHANDLE  0       /* file handle */
   #define ENUMEA_REFTYPE_PATH     1       /* path name */
   #define ENUMEA_REFTYPE_MAX      ENUMEA_REFTYPE_PATH

USHORT APIENTRY DosClose    (USHORT);
USHORT APIENTRY DosOpen     (const char __far *, USHORT __far *, unsigned int __far *, unsigned long, unsigned int, unsigned int, unsigned int, unsigned long);
USHORT APIENTRY DosRead     (USHORT, void __far *, USHORT, USHORT __far *);
USHORT APIENTRY DosWrite    (USHORT, void __far *, USHORT, USHORT __far *);
USHORT APIENTRY DosBufReset (USHORT);
USHORT APIENTRY DosChdir    (const char __far *);
USHORT APIENTRY DosChgFilePtr (USHORT, long, USHORT, long __far *);
USHORT APIENTRY DosDelete   (const char __far *, unsigned long);
USHORT APIENTRY DosDupHandle (USHORT, USHORT __far *);
USHORT APIENTRY	DosEditName	(USHORT, UCHAR __far *, UCHAR __far *, UCHAR __far *, USHORT) ;
USHORT APIENTRY DosFileLocks (USHORT, long __far *, long __far *);
USHORT APIENTRY DosFindClose (USHORT) ;
USHORT APIENTRY DosFindFirst (char __far *, USHORT __far *, unsigned int, FILEFINDBUF __far *, unsigned int, unsigned int __far *, unsigned long);
USHORT APIENTRY DosFindNext (USHORT, FILEFINDBUF __far *, unsigned int, unsigned int __far *);
USHORT APIENTRY DosNewSize  (USHORT, unsigned long);
USHORT APIENTRY DosMkdir    (const char __far *, unsigned long);
USHORT APIENTRY DosMove     (const char __far *, const char __far *, unsigned long);
USHORT APIENTRY DosQCurDir  (USHORT, char __far *, USHORT __far *);
USHORT APIENTRY DosQCurDisk (USHORT __far *, unsigned long __far *);
USHORT APIENTRY DosQFHandState (USHORT, USHORT __far *);
USHORT APIENTRY DosQFileInfo (USHORT, USHORT, FILESTATUS __far *, USHORT);
USHORT APIENTRY DosQFileMode (const char __far *, USHORT __far *, unsigned long);
USHORT APIENTRY DosQFSInfo  (USHORT, USHORT, BYTE __far *, USHORT);
USHORT APIENTRY DosQHandType (USHORT, USHORT __far *, USHORT __far *);
USHORT APIENTRY DosQVerify  (USHORT __far *);
USHORT APIENTRY DosQPathInfo (UCHAR __far *, USHORT, FILESTATUS __far *, USHORT, ULONG);
USHORT APIENTRY DosReadAsync (USHORT, unsigned long __far *, USHORT __far *, void __far *, USHORT, USHORT __far *) ;
USHORT APIENTRY DosRmdir    (const char __far *, unsigned long);
USHORT APIENTRY DosSelectDisk (USHORT);
USHORT APIENTRY DosSetFHandState (USHORT, USHORT);
USHORT APIENTRY DosSetFileInfo (USHORT, USHORT, FILESTATUS __far *, USHORT);
USHORT APIENTRY DosSetFileMode (const char __far *, USHORT, unsigned long);
USHORT APIENTRY DosSetFSInfo (USHORT, USHORT, BYTE __far *, USHORT);
USHORT APIENTRY DosSetMaxFH (USHORT);
USHORT APIENTRY DosSetVerify (USHORT);
USHORT APIENTRY DosWriteAsync (USHORT, unsigned long __far *, USHORT __far *, void __far *, USHORT, USHORT __far *) ;

#endif /* INCL_DOSFILEMGR */





#if defined(INCL_DOS) || defined(INCL_DOSMEMMGR)

USHORT APIENTRY DosAllocSeg (USHORT, USHORT __far *, USHORT);
USHORT APIENTRY DosFreeSeg  (USHORT);
USHORT APIENTRY DosMemAvail (ULONG __far *);
USHORT APIENTRY DosReallocSeg (USHORT, USHORT);

#define SEG_GIVEABLE        0x0001
#define SEG_GETTABLE        0x0002
#define SEG_DISCARDABLE     0x0004

USHORT APIENTRY DosLockSeg (USHORT) ;
USHORT APIENTRY DosUnlockSeg (USHORT) ;

USHORT APIENTRY DosAllocHuge (USHORT, USHORT, USHORT __far *, USHORT, USHORT);
USHORT APIENTRY DosGetHugeShift (USHORT __far *);
USHORT APIENTRY DosReallocHuge (USHORT, USHORT, USHORT);

USHORT APIENTRY DosAllocShrSeg (UINT, char __far *, USHORT __far *) ;
USHORT APIENTRY DosGiveSeg  (USHORT, USHORT, USHORT __far *);
USHORT APIENTRY DosGetSeg   (USHORT);
USHORT APIENTRY DosGetShrSeg (char __far *, USHORT __far *) ;

USHORT APIENTRY DosSubAlloc (USHORT, USHORT __far *, USHORT);
USHORT APIENTRY DosSubFree  (USHORT, USHORT, USHORT);
USHORT APIENTRY DosSubSet   (USHORT, USHORT, USHORT);

USHORT APIENTRY DosCreateCSAlias (USHORT, USHORT __far *) ;

#endif /* INCL_DOSMEMMGR */


#if defined(INCL_DOS) || defined(INCL_DOSSEMAPHORES)

USHORT APIENTRY DosCloseSem(USHORT);
USHORT APIENTRY DosCreateSem(USHORT, USHORT __far *, UCHAR __far *);
USHORT APIENTRY DosOpenSem(USHORT __far *, UCHAR __far *);
USHORT APIENTRY DosSemClear(USHORT);
USHORT APIENTRY DosSemRequest(USHORT, LONG);
USHORT APIENTRY DosSemSet(USHORT);
USHORT APIENTRY DosSemSetWait(USHORT, LONG);
USHORT APIENTRY DosSemWait(USHORT, LONG);

#define CSEM_PRIVATE    0
#define CSEM_PUBLIC     1

/*
 * Since a MUXSEMLIST structure is actually a variable length
 * structure, the following macro may be used to define a MUXSEMLIST
 * structure having size elements, named "name".
 */
#define DEFINEMUXSEMLIST(name, size) \
	struct {                         \
		USHORT cmxs;                 \
		MUXSEM amxs[size];           \
	} name;

/*
 * This function actually takes a __far pointer to a MUXSEMLIST structure
 * as its second parameter, but in order to allow its use with the
 * DEFINEMUXSEMLIST macro, it is declared here as PVOID.
 */
//USHORT APIENTRY DosMuxSemWait(PUSHORT, PVOID, LONG);

#endif /* INCL_DOSSEMAPHORES */



#if defined(INCL_DOS) || defined(INCL_DOSDATETIME)

USHORT APIENTRY DosGetDateTime (DOSDATETIME __far *);
USHORT APIENTRY DosSetDateTime (DOSDATETIME __far *);

USHORT APIENTRY DosTimerAsync(ULONG, USHORT, USHORT __far *);
USHORT APIENTRY DosTimerStart(ULONG, USHORT, USHORT __far *);
USHORT APIENTRY DosTimerStop(USHORT);

#endif /* INCL_DOSDATETIME */



#if defined(INCL_DOS) || defined(INCL_DOSMODULEMGR)

//USHORT APIENTRY DosLoadModule(PSZ, USHORT, PSZ, PHMODULE);
//USHORT APIENTRY DosFreeModule(HMODULE);
//USHORT APIENTRY DosGetProcAddr(HMODULE, PSZ, PPFN);
//USHORT APIENTRY DosGetModHandle(PSZ, PHMODULE);
//USHORT APIENTRY DosGetModName(HMODULE, USHORT, PCHAR);

#endif /* INCL_DOSMODULEMGR */



#if defined(INCL_DOS) || defined(INCL_DOSNLS)

USHORT APIENTRY DosCaseMap  (USHORT, DOSCOUNTRYCODE __far *, char __far *);
USHORT APIENTRY DosGetCollate (USHORT, DOSCOUNTRYCODE __far *, char __far *, USHORT __far *);
USHORT APIENTRY DosGetCp    (USHORT, USHORT __far *, USHORT __far *);
USHORT APIENTRY DosGetCtryInfo (USHORT, DOSCOUNTRYCODE __far *, DOSCOUNTRYINFO __far *, USHORT __far *);
USHORT APIENTRY DosGetDBCSEv (USHORT, DOSCOUNTRYCODE __far *, char __far *);
USHORT APIENTRY DosSetCp    (USHORT, USHORT);

#endif /* INCL_DOSNLS */



#if defined(INCL_DOS) || defined(INCL_DOSSIGNALS)

#define SIG_CTRLC           1       /* Control C            */
#define SIG_BROKENPIPE      2       /* Broken Pipe          */
#define SIG_KILLPROCESS     3       /* Program Termination  */
#define SIG_CTRLBREAK       4       /* Control Break        */
#define SIG_PFLG_A          5       /* Process Flag A       */
#define SIG_PFLG_B          6       /* Process Flag B       */
#define SIG_PFLG_C          7       /* Process Flag C       */
#define SIG_CSIGNALS        8       /* number of signals plus one */

#define PFLG_A              0       /* Process Flag A       */
#define PFLG_B              1       /* Process Flag B       */
#define PFLG_C              2       /* Process Flag C       */

#define SIGA_KILL           0
#define SIGA_IGNORE         1
#define SIGA_ACCEPT         2
#define SIGA_ERROR          3
#define SIGA_ACKNOWLEDGE    4

#define HLDSIG_ENABLE       0
#define HLDSIG_DISABLE      1

#define FLGP_SUBTREE        0
#define FLGP_PID            1

USHORT APIENTRY DosSetSigHandler (void (APIENTRY *)(USHORT, USHORT), void (APIENTRY * __far *)(USHORT, USHORT), unsigned int __far *, unsigned int, unsigned int) ;
//USHORT APIENTRY DosFlagProcess(PID, USHORT, USHORT, USHORT);
//USHORT APIENTRY DosHoldSignal(USHORT);
//USHORT APIENTRY DosSendSignal(USHORT, USHORT);

#endif /* INCL_DOSSIGNALS */




#if defined(INCL_DOS) || defined(INCL_DOSMONITORS)

//USHORT APIENTRY   DosMonClose () ;
//USHORT APIENTRY   DosMonOpen () ;
//USHORT APIENTRY   DosMonRead () ;
//USHORT APIENTRY   DosMonReg () ;
//USHORT APIENTRY   DosMonWrite () ;

#endif /* DOS_MONITORS */


#if defined(INCL_DOS) || defined(INCL_DOSQUEUES)
USHORT APIENTRY DosMakePipe (USHORT __far *, USHORT __far *, UINT) ;
//USHORT APIENTRY DosCloseQueue(HQUEUE);
//USHORT APIENTRY DosCreateQueue(PHQUEUE, USHORT, PSZ);
//USHORT APIENTRY DosOpenQueue(PUSHORT, PHQUEUE, PSZ);
//USHORT APIENTRY DosPeekQueue(HQUEUE, PULONG, PUSHORT, PULONG, PUSHORT, USHORT, PBYTE, HSEM);
//USHORT APIENTRY DosPurgeQueue(HQUEUE);
//USHORT APIENTRY DosQueryQueue(HQUEUE, PUSHORT);
//USHORT APIENTRY DosReadQueue(HQUEUE, PULONG, PUSHORT, PULONG, USHORT, USHORT, PBYTE, HSEM);
//USHORT APIENTRY DosWriteQueue(HQUEUE, USHORT, USHORT, PBYTE, USHORT);
#endif /* INCL_DOSQUEUES */


#if defined(INCL_DOS) || defined(INCL_DOSMISC)

USHORT APIENTRY DosErrClass (USHORT, USHORT __far *, USHORT __far *, USHORT __far *);
USHORT APIENTRY DosError    (USHORT);
USHORT APIENTRY DosSetVec   (USHORT, int (APIENTRY *)(void), int (APIENTRY * __far *)(void));

USHORT APIENTRY DosGetEnv   (USHORT __far *, USHORT __far *) ;
USHORT APIENTRY DosGetMachineMode (unsigned char __far *);
USHORT APIENTRY DosGetVersion (USHORT __far *);
USHORT APIENTRY DosScanEnv  (const char __far *, const char __far * __far *);
USHORT APIENTRY DosSearchPath (USHORT, const char __far *, const char __far *, unsigned char __far *, USHORT);

USHORT APIENTRY DosGetMessage (char __far * __far *, USHORT, char __far *, USHORT, USHORT, char __far *, USHORT __far *);
USHORT APIENTRY DosInsMessage (char __far * __far *, USHORT, char __far *, USHORT, char __far *, USHORT, USHORT __far *);
USHORT APIENTRY DosPutMessage (int, USHORT, char __far *);

#endif /* INCL_DOSMISC */

#if defined(INCL_DOS) || defined(INCL_DOSSESMGR)

struct STARTDATA {
	USHORT cb;
	USHORT Related;
	USHORT FgBg;
	USHORT TraceOpt;
	const UCHAR __far *PgmTitle;
	const UCHAR __far *PgmName;
	BYTE  __far *PgmInputs;
	BYTE  __far *TermQ;
} ;

struct STARTDATA2 : public STARTDATA {
	BYTE  __far *Environment ;
	USHORT	InheritOpt ;
} ;

struct STARTDATA3 : public STARTDATA2 {
	USHORT	SessionType ;
	UCHAR __far *IconFile ;
	ULONG	PgmHandle ;
	USHORT	PgmControl ;
	USHORT	InitXPos ;
	USHORT	InitYPos ;
	USHORT	InitXSize ;
	USHORT	InitYSize ;
} ;

USHORT APIENTRY DosStartSession(STARTDATA __far *, USHORT __far *, USHORT __far *);
USHORT APIENTRY DosSetSession(USHORT, STATUSDATA __far *);
USHORT APIENTRY DosSelectSession(USHORT, ULONG);
USHORT APIENTRY DosStopSession(USHORT, USHORT, ULONG);

#endif /* INCL_DOSSESMGR */



#if defined(INCL_DOS) || defined(INCL_DOSDEVICES)

USHORT APIENTRY DosCLIAccess (void) ;
USHORT APIENTRY DosDevConfig (void __far *, UINT, UINT) ;
USHORT APIENTRY DosDevIOCtl (void __far *, void __far *, UINT, UINT, UINT);
USHORT APIENTRY DosDevIOCtl2 (void __far *, USHORT, void __far *, USHORT, UINT, UINT, UINT);
USHORT APIENTRY DosPhysicalDisc (UINT, unsigned char __far *, UINT, unsigned char __far *, UINT) ;
USHORT APIENTRY DosPortAccess (UINT, UINT, UINT, UINT) ;

//USHORT APIENTRY	DosPTrace () ;
//USHORT APIENTRY	DosSystemService(USHORT, void __far *, void __far *);


#endif /* INCL_DOSDEVICES */

}
