//
//    *******************************************************************
//      JdeBP C++ Library Routines      General Public Licence v1.00
//          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
//    *******************************************************************
//

//
//  OS/2 MOU API
//

#ifndef _MOUTYPES_DEFINED

typedef struct _PTRLOC {
		USHORT row;
		USHORT col;
} PTRLOC;

typedef struct _PTRSHAPE {
		USHORT cb;
		USHORT col;
		USHORT row;
		USHORT colHot;
		USHORT rowHot;
} PTRSHAPE;

typedef struct _MOUEVENTINFO {
		USHORT fs;
		ULONG  Time;
		USHORT row;
		USHORT col;
} MOUEVENTINFO;

typedef struct _MOUQUEINFO {
		USHORT cEvents;
		USHORT cmaxEvents;
} MOUQUEINFO;

typedef struct _SCALEFACT {
		USHORT rowScale;
		USHORT colScale;
} SCALEFACT;

typedef struct _NOPTRRECT {
		USHORT row;
		USHORT col;
		USHORT cRow;
		USHORT cCol;
} NOPTRRECT;

#define _MOUTYPES_DEFINED
#endif

extern "C" {

USHORT APIENTRY Mou16Register ( const UCHAR far *, const UCHAR far *, ULONG );

USHORT APIENTRY Mou16DeRegister ( void );

USHORT APIENTRY Mou16FlushQue ( USHORT );

#define MHK_BUTTON1         0x0001
#define MHK_BUTTON2         0x0002
#define MHK_BUTTON3         0x0004

USHORT APIENTRY Mou16GetHotKey ( USHORT far *, USHORT );
USHORT APIENTRY Mou16SetHotKey ( USHORT far *, USHORT );

USHORT APIENTRY Mou16GetPtrPos ( PTRLOC far *, USHORT );
USHORT APIENTRY Mou16SetPtrPos ( PTRLOC far *, USHORT );

USHORT APIENTRY Mou16SetPtrShape ( BYTE far *, PTRSHAPE far *, USHORT );
USHORT APIENTRY Mou16GetPtrShape ( BYTE far *, PTRSHAPE far *, USHORT );

USHORT APIENTRY Mou16GetDevStatus ( USHORT far *, USHORT );

USHORT APIENTRY Mou16GetNumButtons ( USHORT far *, USHORT );
USHORT APIENTRY Mou16GetNumMickeys ( USHORT far *, USHORT );

USHORT APIENTRY Mou16ReadEventQue ( MOUEVENTINFO far *, USHORT far *, USHORT );

USHORT APIENTRY Mou16GetNumQueEl ( MOUQUEINFO far *, USHORT );

USHORT APIENTRY Mou16GetEventMask ( USHORT far *, USHORT );
USHORT APIENTRY Mou16SetEventMask ( USHORT far *, USHORT );

USHORT APIENTRY Mou16GetScaleFact ( SCALEFACT far *, USHORT );
USHORT APIENTRY Mou16SetScaleFact ( SCALEFACT far *, USHORT );

USHORT APIENTRY Mou16Open ( const UCHAR far *, USHORT far * );
USHORT APIENTRY Mou16Close ( USHORT );

USHORT APIENTRY Mou16RemovePtr ( NOPTRRECT far *, USHORT );

USHORT APIENTRY Mou16DrawPtr ( USHORT );

USHORT APIENTRY Mou16SetDevStatus ( USHORT far *, USHORT );
USHORT APIENTRY Mou16InitReal ( const UCHAR far * );

USHORT APIENTRY Mou16Synch ( USHORT );

}
