//
//    *******************************************************************
//      JdeBP C++ Library Routines      General Public Licence v1.00
//          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
//    *******************************************************************
//

//
//  OS/2 VIO API
//

#ifndef _VIOTYPES_DEFINED
typedef struct _VIOCURSORINFO {
		short   yStart;				// May have negative values
		short   cEnd;				// May have negative values
		short   cx;
		short   attr;				// May have negative values
} VIOCURSORINFO;

typedef struct _VIOMODEINFO {
        unsigned short cb;
        unsigned char  fbType;
        unsigned char  color;
        unsigned short col;
        unsigned short row;
        unsigned short hres;
        unsigned short vres;
        unsigned char  fmt_ID;
        unsigned char  attrib;
} VIOMODEINFO;

typedef struct _VIOPHYSBUF {
        unsigned char far * pBuf;
        unsigned long       cb;
        unsigned short      asel[1];
} VIOPHYSBUF;

typedef struct _VIOCONFIGINFO {
        unsigned short  cb     ;
        unsigned short  adapter;
        unsigned short  display;
        unsigned long   cbMemory;
} VIOCONFIGINFO;

typedef struct _VIOFONTINFO {
        unsigned short  cb;
        unsigned short  type;
        unsigned short  cxCell;
        unsigned short  cyCell;
        void far *      pbData;
        unsigned short  cbData;
} VIOFONTINFO;

typedef struct _VIOPALSTATE {
        unsigned short  cb;
        unsigned short  type;
        unsigned short  iFirst;
        unsigned short  acolor[1];
}VIOPALSTATE;

typedef struct _VIOOVERSCAN {
        unsigned short  cb;
        unsigned short  type;
        unsigned short  color;
}VIOOVERSCAN;

typedef struct _VIOINTENSITY {
        unsigned short  cb;
        unsigned short  type;
        unsigned short  fs;
}VIOINTENSITY;
#define _VIOTYPES_DEFINED
#endif

extern "C" {

	USHORT APIENTRY Vio16Register ( unsigned char far *, unsigned char far *, unsigned long, unsigned long );

	USHORT APIENTRY Vio16DeRegister ( void );

	USHORT APIENTRY Vio16GetBuf ( unsigned long far *, unsigned short far *, unsigned short );

	USHORT APIENTRY Vio16GetCurPos ( unsigned short far *, unsigned short far *, unsigned short );
	USHORT APIENTRY Vio16SetCurPos ( unsigned short, unsigned short, unsigned short );

	USHORT APIENTRY Vio16GetCurType ( VIOCURSORINFO far *, unsigned short );
	USHORT APIENTRY Vio16SetCurType ( VIOCURSORINFO far *, unsigned short );

#define VGMT_MONOCHROME     0x00
#define VGMT_OTHER          0x01
#define VGMT_GRAPHICS       0x02
#define VGMT_DISABLEBURST   0x04

	USHORT APIENTRY Vio16GetMode ( VIOMODEINFO far *, unsigned short );
	USHORT APIENTRY Vio16SetMode ( const VIOMODEINFO far *, unsigned short );

	USHORT APIENTRY Vio16GetPhysBuf ( VIOPHYSBUF far *, unsigned short );

	USHORT APIENTRY Vio16ReadCellStr ( char far *, unsigned short far *, unsigned short, unsigned short, unsigned short );
	USHORT APIENTRY Vio16ReadCharStr ( char far *, unsigned short far *, unsigned short, unsigned short, unsigned short );
	USHORT APIENTRY Vio16WrtCellStr ( const char far *, unsigned short, unsigned short, unsigned short, unsigned short );
	USHORT APIENTRY Vio16WrtCharStr ( const char far *, unsigned short, unsigned short, unsigned short, unsigned short );

	USHORT APIENTRY Vio16ScrollDn ( unsigned short, unsigned short, unsigned short, unsigned short, unsigned short, unsigned char far *,  unsigned short );
	USHORT APIENTRY Vio16ScrollUp ( unsigned short, unsigned short, unsigned short, unsigned short, unsigned short, unsigned char far *,  unsigned short );
	USHORT APIENTRY Vio16ScrollLf ( unsigned short, unsigned short, unsigned short, unsigned short, unsigned short, unsigned char far *,  unsigned short );
	USHORT APIENTRY Vio16ScrollRt ( unsigned short, unsigned short, unsigned short, unsigned short, unsigned short, unsigned char far *,  unsigned short );

	USHORT APIENTRY Vio16WrtNAttr ( unsigned const char far *, unsigned short, unsigned short, unsigned short, unsigned short );
	USHORT APIENTRY Vio16WrtNCell ( unsigned const char far *, unsigned short, unsigned short, unsigned short, unsigned short );
	USHORT APIENTRY Vio16WrtNChar ( const char far *, unsigned short, unsigned short, unsigned short, unsigned short );
	USHORT APIENTRY Vio16WrtTTy ( const char far *, unsigned short, unsigned short );
	USHORT APIENTRY Vio16WrtCharStrAtt ( const char far *, unsigned short, unsigned short, unsigned short, const unsigned char far *, unsigned short );

	USHORT APIENTRY Vio16ShowBuf ( unsigned short, unsigned short, unsigned short );

#define ANSI_ON     1
#define ANSI_OFF    0

	USHORT APIENTRY Vio16SetAnsi ( unsigned short, unsigned short );
	USHORT APIENTRY Vio16GetAnsi ( unsigned short far *, unsigned short );

	USHORT APIENTRY Vio16PrtSc ( unsigned short );
	USHORT APIENTRY Vio16PrtScToggle ( unsigned short );

#define VSRWI_SAVEANDREDRAW  0
#define VSRWI_REDRAW         1

#define VSRWN_SAVE           0
#define VSRWN_REDRAW         1

#define UNDOI_GETOWNER          0
#define UNDOI_RELEASEOWNER      1

#define UNDOK_ERRORCODE         0
#define UNDOK_TERMINATE         1

	USHORT APIENTRY Vio16SavRedrawWait ( unsigned short, unsigned short far *, unsigned short);
	USHORT APIENTRY Vio16SavRedrawUndo ( unsigned short, unsigned short, unsigned short );

#define VMWR_POPUP  0
#define VMWN_POPUP  0

	USHORT APIENTRY Vio16ModeWait ( unsigned short, unsigned short far *, unsigned short );
	USHORT APIENTRY Vio16ModeUndo ( unsigned short, unsigned short, unsigned short );

#define LOCKIO_NOWAIT   0
#define LOCKIO_WAIT     1

#define LOCK_SUCCESS    0
#define LOCK_FAIL       1

	USHORT APIENTRY Vio16ScrLock ( unsigned short, unsigned char far *, unsigned short );
	USHORT APIENTRY Vio16ScrUnLock ( unsigned short );

#define VP_NOWAIT       0x0000
#define VP_WAIT         0x0001
#define VP_OPAQUE       0x0000
#define VP_TRANSPARENT  0x0002

	USHORT APIENTRY Vio16PopUp ( unsigned short far *, unsigned short );
	USHORT APIENTRY Vio16EndPopUp ( unsigned short );

	USHORT APIENTRY Vio16GetConfig ( unsigned short, VIOCONFIGINFO far *, unsigned short );

#define VGFI_GETCURFONT     0
#define VGFI_GETROMFONT     1

	USHORT APIENTRY Vio16GetFont ( VIOFONTINFO far *, unsigned short );
	USHORT APIENTRY Vio16SetFont ( VIOFONTINFO far *, unsigned short );

	USHORT APIENTRY Vio16GetCp ( unsigned short, unsigned short far *, unsigned short );
	USHORT APIENTRY Vio16SetCp ( unsigned short, unsigned short, unsigned short );

	USHORT APIENTRY Vio16GetState ( void far *, unsigned short );
	USHORT APIENTRY Vio16SetState ( void far *, unsigned short );


}
