//
//      **************************************************************
//       JdeBP C++ Library Routines      General Public Licence v1.00
//          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
//      **************************************************************
//
//  STANDARD LIBRARY ROUTINES (ANSI)
//

#if !defined(___STDDEF_H_INCLUDED)
#include <_stddef.h>
#endif

#if !defined(__STDLIB_H_INCLUDED)

#define NULL    _NULL

#define EXIT_FAILURE 1          /* Code for unsuccessful termination    */
#define EXIT_SUCCESS 0          /* Code for successful termination      */

#define RAND_MAX 0x7fff         /* Maximum of rand()    */

#define _NATFUNCS   32

#if _MSDOS_SOURCE
#   if _MSC_VER >= 600
#       define _MAX_PATH    260         /* Max len of full pathname     */
#       define _MAX_DRIVE   3           /* Max len of drive component   */
#       define _MAX_DIR     256         /* Max len of path component    */
#       define _MAX_FNAME   256         /* Max len of file name         */
#       define _MAX_EXT     256         /* Max len of extension         */
#   else
#       define _MAX_PATH    144         /* Max len of full pathname     */
#       define _MAX_DRIVE   3           /* Max len of drive component   */
#       define _MAX_DIR     130         /* Max len of path component    */
#       define _MAX_FNAME   9           /* Max len of file name         */
#       define _MAX_EXT     5           /* Max len of extension         */
#   endif
#endif

#ifndef _DIV_T_DEFINED
typedef struct _div_t   { int quot;     int rem; }  div_t;
typedef struct _ldiv_t  { long quot;    long rem; } ldiv_t;
#define _DIV_T_DEFINED
#endif

#ifndef _SIZE_T_DEFINED
typedef _Size_t size_t;
#define _SIZE_T_DEFINED
#endif

#ifndef _WCHAR_T_DEFINED
typedef _Wchar_t wchar_t;
#define _WCHAR_T_DEFINED
#endif

/* Maximum len of multibyte character   */
#define MB_CUR_MAX  _Mbstate::_Mbcurmax

#ifndef _MBSTATE_DEFINED
class _Mbstate {
	const char far *table ;
	short state ;
public:
	_Mbstate(const char __far *t, short s) : table(t), state(s) {}
	~_Mbstate() {}
	static unsigned char	__cdecl  _Mbcurmax ;
	int     __cdecl  _Mbtowc     ( wchar_t *, const char *, size_t );
} ;
extern  _Mbstate        __cdecl  _Mbs_mblen, _Mbs_mbtowc;
#define _MBSTATE_DEFINED
#endif

extern "C" {

void    __cdecl  abort       (void);
int     __cdecl  abs         (int);
int     __cdecl  atexit      (void (__cdecl *)(void));
double  __cdecl  atof        (const char *);
int     __cdecl  atoi        (const char *);
long    __cdecl  atol        (const char *);
void *  __cdecl  bsearch     (const void *, const void *, size_t, size_t,
							int (__cdecl *)(const void *, const void *));
void *  __cdecl  calloc      (size_t, size_t);
div_t   __cdecl  div         (int, int);
void    __cdecl  exit        (int);
void    __cdecl  free        (void *);
char *  __cdecl  getenv      (const char *);
long    __cdecl  labs        (long);
ldiv_t  __cdecl  ldiv        (long, long);
void *  __cdecl  malloc      (size_t);
int     __cdecl  mblen       (const char *, size_t);
size_t  __cdecl  mbstowcs    (wchar_t *, const char *, size_t);
int     __cdecl  mbtowc      (wchar_t *, const char *, size_t);
void    __cdecl  qsort       (void *, size_t, size_t,
							int (__cdecl *)(const void *, const void *));
int     __cdecl  rand        (void);
void *  __cdecl  realloc     (void *, size_t);
void    __cdecl  srand       (unsigned int);
double  __cdecl  strtod      (const char *, char **);
long    __cdecl  strtol      (const char *, char **, int);
unsigned long   __cdecl  strtoul (const char *, char **, int);
int     __cdecl  system      (const char *);
size_t  __cdecl  wcstombs    (char *, const wchar_t *, size_t);
int     __cdecl  wctomb      (char *, wchar_t);

#if _POSIX1_SOURCE > 1
int     __cdecl  putenv      (const char *);
int     __cdecl  clearenv    (void);
char *  __cdecl  setenv      (const char *, const char *);
int     __cdecl  unsetenv    (const char *);
#endif

#if _MSDOS_SOURCE > 0
char *  __cdecl  itoa        (int, char *, int);
char *  __cdecl  ltoa        (long, char *, int);
char *  __cdecl  ultoa       (unsigned long, char *, int);
#endif

#if _MSDOS_SOURCE > 1
char *  __cdecl  ultor       (unsigned long, char *, int);
#endif

void    __cdecl  _exit       (int);

int     __cdecl  _Wctomb     ( char *, wchar_t, char * );

unsigned long   __cdecl  _Strtoul    (const char *, char **, int);

extern  unsigned long   __cdecl  _RandSeed;
extern  int             __cdecl  _Envc;
extern  char **         __cdecl  _Environ;

#if _MSDOS_SOURCE > 0
extern const char * __cdecl sys_errlist[];       // Error messages
extern const int __cdecl sys_nerr;               // Size of above
#endif

}

#define srand(x)    (void)(_RandSeed = (x))

#define strtoul(s,e,b)	_Strtoul(s,e,b)
#define atoi(s)			(int)strtol(s,NULL,10)
#define atol(s)			strtol(s,NULL,10)

#define mblen(s,n)      _Mbs_mblen._Mbtowc(NULL,s,n)
#define mbtowc(pwc,s,n) _Mbs_mbtowc._Mbtowc(pwc,s,n)

#if _MSDOS_SOURCE
#define max(a,b)    (((a) > (b)) ? (a) : (b))
#define min(a,b)    (((a) < (b)) ? (a) : (b))
#endif

#if _POSIX_SOURCE
#define environ _Environ            // Not actually required by the standard
#endif

#define __STDLIB_H_INCLUDED
#endif

