//
//      **************************************************************
//       JdeBP C++ Library Routines      General Public Licence v1.00
//          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
//      **************************************************************
//
//  STRING ROUTINES (ANSI)
//

#if !defined(___STDDEF_H_INCLUDED)
#include <_stddef.h>
#endif

#if !defined(__STRING_H_INCLUDED)

#define NULL    _NULL

#ifndef _SIZE_T_DEFINED
typedef _Size_t size_t;
#define _SIZE_T_DEFINED
#endif

extern "C" {

void *  __cdecl  memchr      (const void *, int, size_t);
int     __cdecl  memcmp      (const void *, const void *, size_t);
void *  __cdecl  memcpy      (void *, const void *, size_t);
void *  __cdecl  memmove     (void *, const void *, size_t);
void *  __cdecl  memset      (void *, int, size_t);

char *  __cdecl  strcat      (char *, const char *);
char *  __cdecl  strchr      (const char *, int);
int     __cdecl  strcmp      (const char *, const char *);
int     __cdecl  strcoll     (const char *, const char *);
char *  __cdecl  strcpy      (char *, const char *);
size_t  __cdecl  strcspn     (const char *, const char *);
char *  __cdecl  strerror    (int);
size_t  __cdecl  strlen      (const char *);
char *  __cdecl  strncat     (char *, const char *, size_t);
int     __cdecl  strncmp     (const char *, const char *, size_t);
char *  __cdecl  strncpy     (char *, const char *, size_t);
char *  __cdecl  strpbrk     (const char *, const char *);
char *  __cdecl  strrchr     (const char *, int);
size_t  __cdecl  strspn      (const char *, const char *);
char *  __cdecl  strstr      (const char *, const char *);
char *  __cdecl  strtok      (char *, const char *);
size_t  __cdecl  strxfrm     (char *, const char *, size_t);

/* ************************************************************************ *\
 * These names reserved in the namespace for "future use" by this header.   *
 *                                                                          *
 * The standard ANSI library code may not rely on these names being present *
 * either as macros or as functions, or them performing any set action.     *
\* ************************************************************************ */

//
// Defined for **IX compatibility
//
void *  __cdecl  memccpy     (void *, const void *, int, unsigned int);
int     __cdecl  memicmp     (const void *, const void *, unsigned int);
void    __cdecl  movedata    (unsigned int, unsigned int, unsigned int, unsigned int, unsigned int);

int     __cdecl  strcmpi     (const char *, const char *);
char *  __cdecl  strdup      (const char *);
int     __cdecl  stricmp     (const char *, const char *);
char *  __cdecl  strlwr      (char *);
int     __cdecl  strncmpi    (const char *, const char *, size_t);
int     __cdecl  strnicmp    (const char *, const char *, size_t);
char *  __cdecl  strnset     (char *, int, size_t);
char *  __cdecl  strrev      (char *);
char *  __cdecl  strset      (char *, int);
char *  __cdecl  strupr      (char *);

//
// Additions to **IX string library
//
void *  __cdecl  memrchr     (const void *, int, size_t) ;
int     __cdecl  strblank    (const char *);
char *  __cdecl  strbmatch   (const char *, const char **);
int     __cdecl  strchg      (char *, char, char);
char *  __cdecl  strdel      (char *, const char *);
char *  __cdecl  strdela     (char *, const char *);
char *  __cdecl  strend      (const char *);
int     __cdecl  strichg     (char *, char, char);
char *  __cdecl  stridel     (char *, const char *);
char *  __cdecl  stridela    (char *, const char *);
char *  __cdecl  strins      (char *, const char *, size_t);
int     __cdecl  striocc     (const char *, char);
char *  __cdecl  strischg    (char *, const char *, const char *);
char *  __cdecl  stristr     (const char *, const char *);
char *  __cdecl  strisrep    (char *, const char *, const char *);
char *  __cdecl  strljust    (char *);
char *  __cdecl  strltrim    (char *);
int     __cdecl  strmatch    (const char *, const char *);
char *  __cdecl  strmid      (const char *, size_t, size_t);
char *  __cdecl  strndup     (const char *, size_t);
size_t  __cdecl  strnlen     (const char *, size_t);
int     __cdecl  strocc      (const char *, char);
char *  __cdecl  strrjust    (char *);
char *  __cdecl  strrol      (char *, size_t);
char *  __cdecl  strror      (char *, size_t);
char *  __cdecl  strrstr     (const char *, const char*);
char *  __cdecl  strrtrim    (char *);
char *  __cdecl  strschg     (char *, const char *, const char *);
char *  __cdecl  strsetsz    (char *, size_t);
char *  __cdecl  strshl      (char *, size_t);
char *  __cdecl  strshr      (char *, size_t);
int     __cdecl  strsocc     (const char *, const char *);
char *  __cdecl  strsrep     (char *, const char *, const char *);
char *  __cdecl  struplw     (char *);

#if __BORLANDC__

//
// Borland C uses a system whereby __double_underscore_functions__ are
// expanded to inline code by the compiler.
//
void *  __cdecl  __memchr__  (const void *, int, size_t);
int     __cdecl  __memcmp__  (const void *, const void *, size_t);
void *  __cdecl  __memcpy__  (void *, const void *, size_t);
void *  __cdecl  __memset__  (void *, int, size_t);
char *  __cdecl  __stpcpy__  (char *, const char *);
char *  __cdecl  __strcat__  (char *, const char *);
char *  __cdecl  __strchr__  (const char *, int);
int     __cdecl  __strcmp__  (const char *, const char *);
char *  __cdecl  __strcpy__  (char *, const char *);
size_t  __cdecl  __strlen__  (const char *);
char *  __cdecl  __strncat__ (char *, const char *, size_t);
int     __cdecl  __strncmp__ (const char *, const char *, size_t);
char *  __cdecl  __strncpy__ (char *, const char *, size_t);
char *  __cdecl  __strnset__ (char *, int, size_t);
char *  __cdecl  __strrchr__ (const char *, int);
char *  __cdecl  __strset__  (char *, int);

#endif

}

#define strcmpi(s,d)    stricmp(s,d)
#define strncmpi(s,d,n) strnicmp(s,d,n)

#define __STRING_H_INCLUDED
#endif
