/*  strstream.h -- class strstream declarations

    Copyright (c) 1990, 1991 by Borland International
    All rights reserved
*/

#ifndef __cplusplus
#error Must use C++ for the type strstream.
#endif

#ifndef __STRSTREAM_H
#define __STRSTREAM_H

#if !defined(__STDDEF_H_INCLUDED)
#include <_stddef.h>
#endif

#if !defined(_IOSTREAM_H_INCLUDED)
#include <iostream.h>
#endif

#pragma option -Vo-

class strstreambuf ;
class strstreambase ;
class istrstream ;
class ostrstream ;
class strstream ;

class strstreambuf : public streambuf {
public:
	strstreambuf();
	strstreambuf(int n);
	strstreambuf(void * (*a)(long), void (*f)(void *));
	strstreambuf( signed char * _s, int,
						 signed char * _strt=0);
	strstreambuf( unsigned char * _s, int,
						 unsigned char * _strt=0);
	~strstreambuf();

	void    freeze(int = 1);
	char * str();
virtual int doallocate();
virtual int overflow(int);
virtual int underflow();
virtual int sync();
virtual streambuf * setbuf(char *, int);
virtual streampos  seekoff(streamoff, ios::seek_dir, int);

private:
	void * (*allocf)(long);
	void    (*freef)(void *);
	short   ssbflags;
	enum    { dynamic = 1, frozen = 2, unlimited = 4 };
	int next_alloc;

	void    init(signed char *, int, signed char *);
};


class strstreambase : public virtual ios {
public:
	strstreambuf * rdbuf() { return &this->buf; }

protected:
		strstreambase(char *, int, char *);
		strstreambase();
		~strstreambase();
private:
		strstreambuf buf;
};


class istrstream : public strstreambase, public istream {
public:
		istrstream(char *);
		istrstream(char *, int);
		~istrstream();
};


class ostrstream : public strstreambase, public ostream {
public:
		ostrstream(char *, int, int = ios::out);
		ostrstream();
		~ostrstream();

	char * str()    { return strstreambase::rdbuf()->str(); }
	int    pcount() { return strstreambase::rdbuf()->out_waiting(); }
};


class strstream : public strstreambase, public iostream {
public:
		strstream();
		strstream(char *, int _sz, int _m);
		~strstream();

	char * str() { return strstreambase::rdbuf()->str(); }
};

#pragma option -Vo.

#endif
