//
//      **************************************************************
//       JdeBP C++ Library Routines      General Public Licence v1.00
//          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
//      **************************************************************
//
//  STANDARD SYSTEM CALL INTERFACE (POSIX)
//

#if !defined(___STDDEF_H_INCLUDED)
#include <_stddef.h>
#endif

#if !defined(__UNISTD_H_INCLUDED)

#define _POSIX_VERSION  199009L /* We conform to revised standard if we can */

#undef  _POSIX_JOB_CONTROL      /* On a single-tasking OS?  You jest. */
#undef  _POSIX_SAVED_IDS        /* Not even under Netware */
#define _POSIX_CHOWN_RESTRICTED -1  /* Always restricted */
#undef  _POSIX_NO_TRUNC         /* Yes on Netware, no on MS-DOS */
#define _POSIX_VDISABLE -1      /* No tty driver on MS-DOS */

#define _SC_ARG_MAX     1
#define _SC_CHILD_MAX   2
#define _SC_CLK_TCK     3
#define _SC_NGROUPS_MAX 4
#define _SC_OPEN_MAX    5
#define _SC_JOB_CONTROL 6
#define _SC_SAVED_IDS   7
#define _SC_VERSION     8
#define _PC_LINK_MAX    9
#define _PC_MAX_CANON   10
#define _PC_MAX_INPUT   11
#define _PC_NAME_MAX    12
#define _PC_PATH_MAX    13
#define _PC_PIPE_BUF    14
#define _PC_CHOWN_RESTRICTED    15
#define _PC_NO_TRUNC    16
#define _PC_VDISABLE    17

#define STDIN_FILENO    0
#define STDOUT_FILENO   1
#define STDERR_FILENO   2

#if _MSDOS_SOURCE > 0
#define STDAUX_FILENO   3
#define STDPRN_FILENO   4
#endif

#if _MSDOS_SOURCE > 0
#define P_WAIT		0 /* synchronous execution */
#define P_NOWAIT	1 /* asynchronous, keep exit code for cwait */
#define P_NOWAITO	3 /* asynchronous, discard exit code */
#define P_DETACH	4 /* detached, discard exit code */
#endif

extern "C" {

// NOTE.  The original POSIX.1 draft uses int and unsigned int instead of
// ssize_t and size_t in some calls.  Because Borland C++ uses strong typing,
// we stick to the second draft declaration rather than mucking about with
// #if's.

void    __cdecl  _exit       (int);

int     __cdecl  access      (const char *, int);
unsigned int    __cdecl  alarm   (unsigned int);
int     __cdecl  chdir       (const char *);
int     __cdecl  chown       (const char *, _Gid_t, _Gid_t);
int     __cdecl  close       (int);
char *  __cdecl  ctermid     (char *);
int     __cdecl  dup         (int);
int     __cdecl  dup2        (int, int);
int     __cdecl  execl       (const char *, const char *, ...);
int     __cdecl  execle      (const char *, const char *, ...);
int     __cdecl  execlp      (const char *, const char *, ...);
int     __cdecl  execlpe     (const char *, const char *, ...);
int     __cdecl  execv       (const char *, const char * const *);
int     __cdecl  execve      (const char *, const char * const *, const char * const *);
int     __cdecl  execvp      (const char *, const char * const *);
int     __cdecl  execvpe     (const char *, const char * const *, const char * const *);
_Pid_t  __cdecl  fork        (void);
long    __cdecl  fpathconf   (int, int);
char *  __cdecl  getcwd      (char *, _Size_t);
_Gid_t  __cdecl  getegid     (void);
_Uid_t  __cdecl  geteuid     (void);
_Gid_t  __cdecl  getgid      (void);
int     __cdecl  getgroups   (int, _Gid_t *);
char *  __cdecl  getlogin    (void);
_Pid_t  __cdecl  getpgrp     (void);
_Pid_t  __cdecl  getpid      (void);
_Pid_t  __cdecl  getppid     (void);
_Uid_t  __cdecl  getuid      (void);
int     __cdecl  isatty      (int);
int     __cdecl  link        (const char *, const char *);
_Off_t  __cdecl  lseek       (int, _Off_t, int);
long    __cdecl  pathconf    (const char *, int);
// pause
int     __cdecl  pipe        (int [2]);
_Ssize_t __cdecl read        (int, void *, _Size_t);
int     __cdecl  rmdir       (const char *);
int     __cdecl  setgid      (_Gid_t) ;              // POSIX.1 ?
int     __cdecl  setpgid     (_Pid_t, _Pid_t) ;      // POSIX.1 ?
_Pid_t  __cdecl  setsid      (void);
int     __cdecl  seteuid     (_Uid_t);
int     __cdecl  setegid     (_Uid_t);               // POSIX.1 ?
unsigned int    __cdecl  sleep   (unsigned int);
long    __cdecl  sysconf     (int);
char *  __cdecl  ttyname     (int fd);
int     __cdecl  unlink      (const char *);
_Ssize_t __cdecl write       (int, const void *, _Size_t);

// This was in the original POSIX.1 standard, but removed in the 1990
// revision.  There is no feature test macro for the 1990 revision.
#if _POSIX1_SOURCE == 1
char *  __cdecl  cuserid     (char *);
#endif

// These are only tentatively declared here, pending the second draft of
// POSIX.1 standard.
#if _POSIX1_SOURCE > 1
int     __cdecl  fchown      (int, _Uid_t, _Gid_t);
int     __cdecl  ftruncate   (int, _Off_t);
#endif

#if _POSIX2_SOURCE > 0
int     __cdecl  fnmatch     (const char *, const char *, int);
int     __cdecl  getopt      (int, const char *[], const char *);
#endif

#if _MSDOS_SOURCE > 0
int     __cdecl  chsize      (int, _Off_t);
int     __cdecl  eof         (int);
_Off_t  __cdecl  filelength  (int);
int     __cdecl  locking     (int, int, _Off_t);
char *  __cdecl  mktemp      (char *);
int     __cdecl  setmode     (int, _Mode_t);
_Off_t  __cdecl  tell        (int);

int     __cdecl  spawnl      (int, const char *, const char *, ...);
int     __cdecl  spawnle     (int, const char *, const char *, ...);
int     __cdecl  spawnlp     (int, const char *, const char *, ...);
int     __cdecl  spawnlpe    (int, const char *, const char *, ...);
int     __cdecl  spawnv      (int, const char *, const char * const *);
int     __cdecl  spawnve     (int, const char *, const char * const *, const char * const *);
int     __cdecl  spawnvp     (int, const char *, const char * const *);
int     __cdecl  spawnvpe    (int, const char *, const char * const *, const char * const *);
#endif

#if _POSIX2_SOURCE > 0
extern  __cdecl  char *  optarg;
extern  __cdecl  int     optind, opterr, optopt;
#endif

long    __cdecl  _pathconf   (int);

}

#define ttyname(fd)     _NULL       /* Can't use NULL in this header */

#if _MSDOS_SOURCE > 0 && _POSIX1_SOURCE > 1
#define chsize(fd,sz)   ftruncate(fd,sz)
#endif

#define __UNISTD_H_INCLUDED
#endif
