//
//      **************************************************************
//       JdeBP C++ Library Routines      General Public Licence v1.00
//          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
//      **************************************************************
//
// PORT I/O and DOS/BIOS INTERRUPTS (MS-DOS)
//

#if !defined(___PORTINT_H_INCLUDED)

//
//  Register packs
//
#ifndef _REGS_DEFINED
struct  WORDREGS {
    unsigned int    ax, bx, cx, dx, si, di, cflag, flags;
};
struct  BYTEREGS {
    unsigned char   al, ah, bl, bh, cl, ch, dl, dh;
};
struct  SREGS   {
    unsigned int    es, cs, ss, ds;
};
union   REGS    {
    struct  WORDREGS x;
    struct  BYTEREGS h;
};
struct  REGPACK {
    unsigned    r_ax, r_bx, r_cx, r_dx;
    unsigned    r_bp, r_si, r_di, r_ds, r_es, r_flags;
};
#define _REGS_DEFINED
#endif

extern "C" {

void        __cdecl  (_disable)  (void);
void        __cdecl  (_enable)   (void);
int         __cdecl  intdos      (union REGS *, union REGS *);
int         __cdecl  intdosx     (union REGS *, union REGS *, struct SREGS *);
int         __cdecl  int86       (int, union REGS *, union REGS *);
int         __cdecl  int86x      (int, union REGS *, union REGS *, struct SREGS *);
void        __cdecl  segread     (struct SREGS *);

int         __cdecl  (inp)   (unsigned);
unsigned    __cdecl  (inpw)  (unsigned);
int         __cdecl  (outp)  (unsigned, int);
unsigned    __cdecl  (outpw) (unsigned, unsigned);

#if __BORLANDC__
unsigned char   __cdecl  inportb (int);
unsigned int    __cdecl  inport  (int);
void            __cdecl  outportb    (int, unsigned char);
void            __cdecl  outport     (int, unsigned int);
#endif

#if __BORLANDC__
//
// Borland C uses a system whereby __double_underscore_functions__ are
// expanded to inline code by the compiler.
//
void        __cdecl      __emit__    (unsigned char __byte, ...);
void        __cdecl      __cli__     (void);
void        __cdecl      __sti__     (void);
void        __cdecl      __int__     (int);
unsigned char   __cdecl  __inportb__ (int);
unsigned int    __cdecl  __inportw__ (int);
void        __cdecl      __outportb__(int, unsigned char);
void        __cdecl      __outportw__(int, unsigned int);
#endif

}

//
//  Macro Overrides
//

#if __BORLANDC__
#define inp(p)          __inportb__(p)
#define outp(p,v)      (__outportb__(p,v), (int)_AL)
#define inpw(p)         __inportw__(p)
#define outpw(p,v)     (__outportw__(p,v), (unsigned)_AX)
#define inportb         __inportb__
#define inport          __inportw__
#define outportb        __outportb__
#define outport         __outportw__
#define disable( )      __emit__( (char)( 0xfa ) )
#define enable( )       __emit__( (char)( 0xfb ) )
#define geninterrupt(i) __int__(i)
#endif

#if __MSC__
#define _disable( ) __emit__( (char )( 0xfa ) ) /* MSC name */
#define _enable( )  __emit__( (char )( 0xfb ) ) /* MSC name */
#endif

#define ___PORTINT_H_INCLUDED
#endif

