//
//      **************************************************************
//       JdeBP C++ Library Routines      General Public Licence v1.00
//          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
//      **************************************************************
//
//  Compiler Specifics
//

#if !defined(___STDDEF_H_INCLUDED)

//
//  Far pointer utilities
//
#if __BORLANDC__
#define     _FP_SEG(p)  ( (unsigned short)(void _seg *)(void far *)(p) )
#define     _FP_OFF(p)  ( (unsigned short)(void near *)            (p) )
#define     _MK_FP(s,o) ( (void _seg *) (s) + (void near *) (o) )
#elif __MSC__
#define     _FP_OFF(p)  ( ((unsigned short _far *)&(p)) [0] )
#define     _FP_SEG(p)  ( ((unsigned short _far *)&(p)) [1] )
#define     _MK_FP(s,o) ( (void _far *) ( (unsigned long)(o) + ( ((unsigned long)(s)) << 16 ) ) )
#endif

//
//  Bases for standard types declared in multiple headers
//
typedef unsigned long   _Nobjectid_t;	// Network object ID type
typedef unsigned long	_Fpos_t;		// fpos_t				(ANSI)
typedef unsigned int	_Wchar_t;		// wchar_t				(ANSI)
typedef unsigned long	_Time_t;		// time_t				(ANSI)
typedef long            _Clock_t;		// clock_t				(ANSI)
#if defined(__HUGE__)||defined(__LARGE__)||defined(__COMPACT__)
typedef signed short	_Ptrdiff_t;		// ptrdiff_t (signed)	(ANSI)
#else
typedef signed long		_Ptrdiff_t;		// ptrdiff_t (signed)	(ANSI)
#endif
typedef unsigned int	_Size_t;		// size_t (unsigned)	(ANSI)
typedef signed int		_Ssize_t;		// ssize_t (signed)		(POSIX.1)
typedef unsigned short	_Dev_t;			// dev_t				(POSIX.1)
typedef _Nobjectid_t	_Gid_t;			// gid_t				(POSIX.1)
typedef unsigned short	_Ino_t;			// ino_t				(POSIX.1)
typedef unsigned short	_Mode_t;		// mode_t				(POSIX.1)
typedef unsigned short	_Nlink_t;		// nlink_t				(POSIX.1)
typedef long			_Off_t;			// off_t (signed)		(POSIX.1)
typedef short			_Pid_t;			// pid_t (signed)		(POSIX.1)
typedef _Nobjectid_t	_Uid_t;			// uid_t				(POSIX.1)
typedef unsigned long	_Sigset_t;		// sigset_t				(POSIX.1)

//
//  Basis for standard macros declared in multiple headers
//
#ifndef _NULL
#define _NULL   ((void *)0)
#define	_FARNULL	0L
#endif
#ifndef	_EOF
#define	_EOF (-1)
#endif

//
//	Standardised keywords
//
#define	__near		near
#define	__far		far
#define	__huge		huge
#define	__pascal	pascal
#define	__cdecl		cdecl
#define	__export	_export

//
//	Calling conventions, export information, and size information
//
//  _FAR                Promote data to __far for use in segmented DLLs
//	_RTLENTRY			Calling convention for RTL functions
//	_USERENTRY			Calling convention from RTL to callback functions
//	_EXPCLASS			Export class when building DLL libraries
//	_EXPDATA			Export data when building DLL libraries
//	_EXPFUNC			Export function when building DLL libraries
//
//  _BUILDDLL			When compiling source for DLL libraries
//  _USEDLL				When using DLL libraries
//

#if defined(__COMPACT__) || defined(__LARGE__) || defined(__HUGE__)
#	define	__FARDATA__
#elif !defined(__FLAT__)
#	define	__NEARDATA__
#endif
#if defined(__MEDIUM__) || defined(__LARGE__) || defined(__HUGE__)
#	define	__FARCODE__
#elif !defined(__FLAT__)
#	define	__NEARCODE__
#endif

#define	_RTLENTRY	__cdecl
#define	_USERENTRY	__cdecl

#if defined(__FLAT__)
#   define _FAR
#   if defined(_BUILDDLL)
#       define _EXPCLASS  __export
#       define _EXPDATA   __export
#       define _EXPFUNC   __export
#   else
#       define _EXPCLASS
#       define _EXPDATA
#       define _EXPFUNC
#   endif
#else
#
#   if defined(_BUILDDLL)
#		define _EXPFUNC __export __far
#		define _EXPCLASS __export __far
#		define _FAR __far
#   elif defined(_USEDLL)
#       define _EXPFUNC __far
#		define _EXPCLASS __huge
#		define _FAR __far
#   else
#       define _EXPFUNC
#       if defined(__NEARDATA__)
#           define _EXPCLASS  __near
#       elif defined(__FARDATA__)
#           define _EXPCLASS  __far
#       else
#           define _EXPCLASS  __huge
#       endif
#		define _FAR
#   endif
#
#endif

// The following macros control the behaviour of the standard headers :
//
// _POSIX_SOURCE        Causes definition of _POSIX1_SOURCE and _POSIX2_...
//                      that reflect the compliancy of this library
// _POSIX1_SOURCE       Controls POSIX.1 compliancy
// _POSIX2_SOURCE       Controls POSIX.2 compliancy
// _MSDOS_SOURCE        Controls MS-DOS API compliancy
// _BSD_SOURCE          Controls BSD **IX library support

#if _POSIX_SOURCE && !defined(_POSIX1_SOURCE) && !defined(_POSIX2_SOURCE)
#define _POSIX1_SOURCE  1
#undef  _POSIX2_SOURCE
#endif

#define ___STDDEF_H_INCLUDED

#endif
